##
##  NGPT - Next Generation POSIX Threading
##  Copyright (c) 2001 IBM Corporation <babt@us.ibm.com>
##  Portions Copyright (c) 1999-2000 Ralf S. Engelschall <rse@engelschall.com>
##
##  This file is part of NGPT a non-preemptive thread scheduling
##  library which can be found at http://www.ibm.com/developer
##
##  This library is free software; you can redistribute it and/or
##  modify it under the terms of the GNU Lesser General Public
##  License as published by the Free Software Foundation; either
##  version 2.1 of the License, or (at your option) any later version.
##
##  This library is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
##  Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public
##  License along with this library; if not, write to the Free Software
##  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
##  USA.
##
##  ngpt.spec: RPM specification 
##

#   This is a specification file for the RedHat Package Manager (RPM).
#   It is part of the ngpt source tree and this way directly included in
#   ngpt distribution tarballs. This way one can use a simple `rpm -tb
#   ngpt-X.Y.Z.tar.gz' command to build binary RPM packages from a ngpt
#   distribution tarball.

%define prefix /
%define ver 1.2.0
%define rel 1

Summary:    NGPT - Next Generation POSIX Threading
Name:       ngpt
Version:    %{ver}
Release:    %{rel}
Group:      System Environment/Libraries
Vendor:	    IBM
Copyright:  LGPL
URL:        http://oss.software.ibm.com/developerworks/opensource/pthreads
Packager:   IBM Corporation <http://oss.software.ibm.com/developerworks/opensource>
Source:     http://oss.software.ibm.com/developerworks/opensource/pthreads/download/stable/source/ngpt-%{ver}.tar.gz
BuildRoot:  /tmp/ngpt-%{ver}-root
Obsoletes:  linuxthreads

%description
NGPT is the user-level portion of a POSIX pthreads library which provides
non-preemptive priority-based scheduling for multiple threads of
execution (aka ``multithreading'') inside event-driven applications. All
threads run in the same address space of the server application, but each
thread has it's own individual program-counter, run-time stack, signal
mask and errno variable.

On SMP machines, this library will use an M:N threading model if enabled
resulting in significantly improved performance.

%package devel
Summary:    NGPT Development Package
Group:	    Development/Libraries
Requires:   ngpt = %{ver}
Obsoletes:  linuxthreads-devel

%description devel
Headers, static libraries, and documentation for NGPT.

%prep

%setup

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{prefix} --enable-batch --enable-optimize --enable-pthread --enable-syscall-hard --enable-maintainer --with-mctx-mth=sjlj --with-mctx-dsp=ssjlj --with-mctx-stk=sas
make
make test

%install
rm -rf $RPM_BUILD_ROOT
make rpm-install prefix=$RPM_BUILD_ROOT%{prefix}/usr

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig
##
## Leave the following commented out until we achieve better binary compatibility
## with glibc/LinuxThreads.
## (cd %{prefix}/lib && cp -f %{prefix}/usr/lib/libpthread.so libpthread-0.9.so && ln -f -s libpthread-0.9.so libpthread.so.0)
## /sbin/ldconfig
##

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc ANNOUNCE AUTHORS COPYING ChangeLog HACKING HISTORY INSTALL NEWS PORTING README SUPPORT TESTS THANKS TODO USERS
%{prefix}/usr/lib/libpthread.so
%{prefix}/usr/lib/libpthread.so.*

%files devel
%defattr(-,root,root)
%{prefix}/usr/bin/pthread-config
%{prefix}/usr/include/pthread.h
%{prefix}/usr/include/semaphore.h
%{prefix}/usr/include/bits/pthreadtypes.h
%{prefix}/usr/include/bits/sigthread.h
%{prefix}/usr/include/bits/local_lim.h
%{prefix}/usr/include/bits/posix_opt.h
%{prefix}/usr/lib/libpthread.a
%{prefix}/usr/lib/libpthread.la
%{prefix}/usr/man/man1/pthread-config.1.gz
%{prefix}/usr/man/man3/pthread.3.gz

